/*
 *  Project   : SPECTRUM - Digital Spectrometric System of Nuclear Radiation
 *
 *  Tool      : ADC Data Acquisition to File header file
 *               
 *  Author(s) : Martin VESKRNA <256569@mail.muni.cz>             
 *
 *  Date      : $Id: storingData.h 326 2014-03-11 10:35:03Z 256569 $
 *
 *  (c) Copyright 2011 MASARYK UNIVERSITY
 *  All rights reserved.
 *
 *  Please review the terms of the license agreement before using this
 *  file. If you are not an authorized user, please destroy this
 *  source code file and notify MASARYK UNIVERSITY immediately that you
 *  inadvertently received an unauthorized copy.
 *
 */
 
#ifndef __STORINGDATA_H_
#define __STORINGDATA_H_
#include <stdio.h>

#define HDD_BUFFER_LENGTH 10000000
#define HDD_BUFFER_STOP 2000
#define HW_CLOCK_MHZ (125.0 + 125.0*0.005296008)
#define HW_SAMPLES_IN_1_PERIOD 16
#define LINE_LENGTH 61
#define DATA_START 45

typedef struct sHDDparams
{
	FILE* outFile_CH1;
	FILE* outFile_CH2;

	char* bufferHDD_CH1;
	char* bufHDDpointer_CH1;
	char* bufHDDstop_CH1;

	char* bufferHDD_CH2;
	char* bufHDDpointer_CH2;
	char* bufHDDstop_CH2;

} tHDDparams;

void HDDParamsInit(tHDDparams *p);
FILE* OpenFile(char* fileName);
void WriteFileHeader(FILE* file, char *comment, int ACD12_dualEdgeSamplingMode, unsigned short threshold, unsigned short offsetPrev, unsigned short offsetPost, char *thresholdOnChannel, float scale, float offset);
void WriteFileHeaderStatistics(FILE *file, unsigned long long catchedPackets, unsigned long long lostPackets);
void inline FlushHDDbuf_CH1(tHDDparams *p);
void inline FlushHDDbuf_CH2(tHDDparams *p);
void inline WriteHexaValue(char* buffer, unsigned char value);
void WriteDecimal(char **buffer, unsigned long value);
void WriteUnsignedInt(char** buffer, unsigned int value);
void WriteUnsignedShort(char** buffer, unsigned short value);
void inline WritePacketsLost(char** bufPointer, unsigned int num, unsigned long long begin, unsigned long long end);
#endif /* STORINGDATA_H_ */
