/*
 *  Project   : SPECTRUM - Digital Spectrometric System of Nuclear Radiation
 *
 *  Tool      : ADC Data Acquisition to File
 *               
 *  Author(s) : Martin VESKRNA <256569@mail.muni.cz>             
 *
 *  Date      : $Id: testing.h 142 2013-05-10 16:33:36Z 256357 $
 *
 *  (c) Copyright 2011 MASARYK UNIVERSITY
 *  All rights reserved.
 *
 *  Please review the terms of the license agreement before using this
 *  file. If you are not an authorized user, please destroy this
 *  source code file and notify MASARYK UNIVERSITY immediately that you
 *  inadvertently received an unauthorized copy.
 *
 */

#ifndef __TESTING_H_
#define __TESTING_H_

 ////////////////////////
 //  TEST PATTERN MODE //
/////////////////////////
 typedef struct sTestParams
{
	unsigned char testPatter_pointer;
	unsigned long long testPatter_time;
	unsigned long long testPatter_checkedPackets;

} tTestParams;

void TestParamsInit(tTestParams *p);
/*
 * function is simmilar to PLL, return number of additional pointer increment
 */
int CheckTestPattern(char* data, unsigned int dataLen, unsigned long long time_HWticks, tTestParams *p);

////////////////////////
//  TIME TEST MODE    //
////////////////////////
//have to be even (not odd)
#define IMPULSES_IN_SEQUENCE 512
#define SAMPLES_IN_PACKET 61
#define IMPULSE_NUM_IN_SEQUENCE 512

#if OFFSET_PREV
	#define DELAY_IN_EMBEDDED_DATA 0
#else
	#define DELAY_IN_EMBEDDED_DATA 1
#endif


typedef struct s_packetAssumption
{
	unsigned char canStartPacket;
	unsigned char isOffsetPrevPost;
	unsigned char FP_LP;
	unsigned int packetLength;
	unsigned int packetNumber;
	unsigned int impulsNumber;

} t_packetAssumption;

union timeUnion
{
	unsigned long long ull;
	char arr[8];

} timeStampExpected;

void PacketAssumptionsPrepare(unsigned int offsetPrev, unsigned int offsetPost);
void PrintPacketAssumptions(unsigned int offsetPrev, unsigned int offsetPost);
void WritePacketContent(unsigned long long timeStamp, char* data, unsigned int dataLen);
void WriteHeaderWithExpecting(unsigned long long timeStamp, unsigned int timeInSequence, unsigned long long packetTested, unsigned int expectedPacketNum, unsigned int packetNumber, unsigned int expectedImpulsNum,
								unsigned int impulsNumber, unsigned char expectedFP_LP, unsigned char FP_LP, unsigned int expectedPacketLength, unsigned int packetLength);
void WriteHeaderWithoutExpecting(unsigned int timeInSequence, unsigned long long timeStamp, unsigned int packetNumber, unsigned int impulsNumber, unsigned char FP_LP, unsigned int packetLength);
void TimeTestMode_TestPacket(unsigned int packetNumber, unsigned int impulsNumber, unsigned long long timeStamp, unsigned char FP_LP, char* data, unsigned int dataLen);

#endif /* TESTING_H_ */
